/*
 * File: gtkcontour.h
 * Auth: John Pavan
*/
#ifndef __GTK_CONTOUR_H__
#define __GTK_CONTOUR_H__

#include <gdk/gdk.h>
#include <gtk/gtkvbox.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  /*
   * --- Macros for conversion and type checking
   */
  #define GTK_CONTOUR(obj) \
    GTK_CHECK_CAST (obj, gtk_contour_get_type(), GtkContour)
  #define GTK_CONTOUR_CLASS(klass) \
    GTK_CHECK_CLASS_CAST (klass, gtk_contour_get_type, GtkContourClass)
  #define GTK_IS_CONTOUR(obj) \
    GTK_CHECK_TYPE(obj, gtk_contour_get_type())

  /*
   * --- Defining data structures
   */

  typedef struct _GtkContour                GtkContour;
  typedef struct _GtkContourClass   GtkContourClass;

  /*
   * --- Here's the contour data
   */

  struct _GtkContour
  {
    GtkWidget vbox;
    gint *values;       // values
    gint num_x_chans;   // number of x channels
    gint num_y_chans;   // number of y channels
    char title[40];
    gint num_points_in_contour[100];
    gint *points_in_contour[100];
    gint num_segments;
    GdkPoint *segments;
  };

  /*
   * Here's the class data
   */

  struct _GtkContourClass
  {
    GtkWidgetClass parent_class;
  };

  /*
   * Function prototypes
   */
  GtkWidget* gtk_contour_new(void);
  void gtk_contour_size (GtkContour *contour, int xsize, int ysize);
  void gtk_contour_set_value (GtkContour *contour, int xindex, int yindex, int value);
  void gtk_contour_title (GtkContour *contour,const char *title);
  void gtk_contour_clear_segments(GtkContour *contour);
  void gtk_contour_add_segment(GtkContour *contour,GdkPoint *point);
  int gtk_contour_has_segements(GtkContour *contour);
  int gtk_contour_has_points(GtkContour *contour,int contourindex);
  void gtk_contour_add_point(GtkContour *contour,int contourindex, GdkPoint *point);
  void gtk_contour_clear_points(GtkContour *contour,int contourindex);
  void gtk_contour_clear_all_points(GtkContour *contour);
  #ifdef __cplusplus
}
#endif */ __cplusplus */

#endif */ __GTK_CONTOUR_H__ */

