#include <gtk/gtk.h>

/* --- Must declare all functions used in menu here --- */

static void MenuTwodRefresh (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodExpand (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodZoomOut (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodWriteBig (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodReadBig (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodClearGates (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodReadGates (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodWriteGates (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodClearGates (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodRedraw (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodGateFill (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPgamReadSetup (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPgamReadMasterSetup (gpointer callback_data, 
				     guint callback_action, GtkWidget *widget);
static void MenuPgamSort (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPrevTwod (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuNextTwod (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPgamReadPgamTwod (gpointer callback_data, 
			      guint callback_action, GtkWidget *widget);
static void MenuPgamWritePgamTwod (gpointer callback_data, 
			      guint callback_action, GtkWidget *widget);
static void MenuPgamTwodProjectFull (gpointer callback_data, 
				     guint callback_action, GtkWidget *widget);
static void MenuTwodMaxOverRideDown (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTwodMaxOverRideUp (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPgamDisplayContourAndDensity(gpointer callback_data,
					     guint callback_action, GtkWidget *widget);
static void MenuPgamDisplayDensity(gpointer callback_data,
					     guint callback_action, GtkWidget *widget);
static void MenuPgamDisplayContour(gpointer callback_data,
					     guint callback_action, GtkWidget *widget);
static void MenuPgamSetNumContours(gpointer callback_data,
				   guint callback_action, GtkWidget *widget);
static void MenuPgamPrint(gpointer callback_data,
				   guint callback_action, GtkWidget *widget);
static void MenuPgamWritePostscript(gpointer callback_data,
				    guint callback_action, GtkWidget *widget);
static void MenuPgamInverseRootContours(gpointer callback_data,
					guint callback_action, GtkWidget *widget);
static void MenuPgamInverseLogContours(gpointer callback_data,
					guint callback_action, GtkWidget *widget);
static void MenuPgamLogContours(gpointer callback_data,
					guint callback_action, GtkWidget *widget);
static void MenuPgamLinearContours(gpointer callback_data,
					guint callback_action, GtkWidget *widget);
static void MenuPgamRootContours(gpointer callback_data,
					guint callback_action, GtkWidget *widget);
static void MenuPgamSetTwodTitle(gpointer callback_data,
				 guint callback_action, GtkWidget *widget);
static void MenuPgamSelect2D(gpointer callback_data,
				 guint callback_action, GtkWidget *widget);
static void MenuPgamClear2D(gpointer callback_data,
				 guint callback_action, GtkWidget *widget);
static void MenuPgamAdd2D(gpointer callback_data,
			  guint callback_action, GtkWidget *widget);
static void MenuPgamSubtract2D(gpointer callback_data,
			  guint callback_action, GtkWidget *widget);
static void MenuPgamColorDensity(gpointer callback_data,
				 guint callback_action, GtkWidget *widget);
static void MenuPgamBWDensity(gpointer callback_data,
			      guint callback_action, GtkWidget *widget);
static void MenuTwodReadFile(gpointer callback_data,
			      guint callback_action, GtkWidget *widget);
static void MenuPgamSetInterpolation(gpointer callback_data,
			      guint callback_action, GtkWidget *widget);
static void MenuPgamSetColorMode(gpointer callback_data,
			      guint callback_action, GtkWidget *widget);
static void MenuPgamSetContourType(gpointer callback_data,
			      guint callback_action, GtkWidget *widget);
static void MenuPgamSetType(gpointer callback_data,
			      guint callback_action, GtkWidget *widget);
static void MenuXCalibration(gpointer callback_data,
			      guint callback_action, GtkWidget *widget);
static void MenuYCalibration(gpointer callback_data,
			      guint callback_action, GtkWidget *widget);
static void MenuPgamSetFadeMode(gpointer (callback_data),
				guint callback_action, GtkWidget *widget);

/*
 * Structure to build the twodplot menus
 */
static GtkItemFactoryEntry twodplot_menu_items[] = {
  {"/_File",                NULL,         0,               0, "<Branch>"},
  {"/File/Read",            NULL,         MenuTwodReadFile,    0 },
  //  {"/File/_Read Big",       NULL,         MenuTwodReadBig, 0,},
  {"/File/_Write Big",      NULL,         MenuTwodWriteBig, 0,},
  // {"/File/Read _Setup",     NULL,         MenuPgamReadSetup, 0},
  //{"/File/Read _Master Setup",NULL,       MenuPgamReadMasterSetup, 0},
  {"/File/Print",           "<control>P",         MenuPgamPrint,   0},
  {"/File/Print To File", NULL,        MenuPgamWritePostscript, 0},
  
  {"/_Manipulate",          NULL,         0,               0, "<Branch>"},
  {"/Manipulate/Set Title", "<control>T", MenuPgamSetTwodTitle, 0},
  {"/Manipulate/Clear 2D",  "<control>C", MenuPgamClear2D,  0},
  {"/Manipulate/Add 2D",    "<control>A", MenuPgamAdd2D, 0},
  {"/Manipulate/Subtract 2D",    "<control>S", MenuPgamSubtract2D, 0},

  {"/_Display",             NULL,         0,               0, "<Branch>"},
  {"/Display/Display",      "D",          MenuPgamSelect2D, 0},
  {"/Display/X Calibration",      "X",          MenuXCalibration, 0},
  {"/Display/Y Calibration",      "Y",          MenuYCalibration, 0},
  {"/Display/_Refresh",     "N",          MenuTwodRefresh, 0},
  {"/Display/_Expand",      "E",          MenuTwodExpand,  0},
  {"/Display/Zoom _Out",    "O",          MenuTwodZoomOut, 0},
  {"/Display/Re_Draw",      "R",          MenuTwodRedraw,  0},
  {"/Display/Next TwoD",    NULL,         MenuNextTwod,    0},
  {"/Display/Prev Twod",    NULL,         MenuPrevTwod,    0},
  {"/Display/Contrast Up",  "C",          MenuTwodMaxOverRideUp,    0},
  {"/Display/Contrast Down",  "<shift>C",          MenuTwodMaxOverRideDown,    0},
  {"/Display/Num Contours", NULL,         MenuPgamSetNumContours, 0},

  {"/Display/Scale Mode", NULL,         0,               0, "<Branch>"},
  {"/Display/Scale Mode/Linear", NULL,  MenuPgamSetContourType, 0 },
  {"/Display/Scale Mode/Log", NULL,     MenuPgamSetContourType, 1},
  {"/Display/Scale Mode/Root", NULL,    MenuPgamSetContourType, 2},
  {"/Display/Scale Mode/Inverse Log", NULL, MenuPgamSetContourType, 3},
  {"/Display/Scale Mode/Inverse Root", NULL, MenuPgamSetContourType, 4},

  {"/Display/Color Mode", NULL,         0,               0, "<Branch>"},
  {"/Display/Color Mode/Color", NULL,        MenuPgamSetColorMode, 0},
  {"/Display/Color Mode/BW", NULL,            MenuPgamSetColorMode, 1},

  {"/Display/Plot Type",    NULL,         0,               0, "<Branch>"},
  {"/Display/Plot Type/Density",  NULL,   MenuPgamSetType,               1},
  {"/Display/Plot Type/Contour",  NULL,   MenuPgamSetType,               0},
  {"/Display/Plot Type/Density and Contour", NULL, MenuPgamSetType,      2},

  {"/Display/Interpolation Mode", NULL,   0,               0, "<Branch>"},
  {"/Display/Interpolation Mode/Off",  NULL, MenuPgamSetInterpolation, 0},
  {"/Display/Interpolation Mode/Linear",  NULL, MenuPgamSetInterpolation, 1},
  {"/Display/Interpolation Mode/Quadratic", NULL, MenuPgamSetInterpolation, 2},
  {"/Display/Interpolation Mode/Cubic", NULL, MenuPgamSetInterpolation, 3},
  {"/Display/Interpolation Mode/Four", NULL, MenuPgamSetInterpolation, 4},
  {"/Display/Interpolation Mode/Five", NULL, MenuPgamSetInterpolation, 5},
  {"/Display/Interpolation Mode/Six", NULL, MenuPgamSetInterpolation, 6},
  {"/Display/Interpolation Mode/Seven", NULL, MenuPgamSetInterpolation, 7},
  {"/Display/Interpolation Mode/Eight", NULL, MenuPgamSetInterpolation, 8},

  {"/Display/Fade Mode", NULL, 0, 0,"<Branch>"},
  {"/Display/Fade Mode/On",NULL, MenuPgamSetFadeMode,0},
  {"/Display/Fade Mode/Off",NULL, MenuPgamSetFadeMode,1},

  {"/_Gates",               NULL,         0,               0, "<Branch>" },
  {"/Gates/_Read Gates",    NULL,         MenuTwodReadGates,   0},
  {"/Gates/_Write Gates",   NULL,         MenuTwodWriteGates,  0},
  {"/Gates/_Clear Gates",   NULL,         MenuTwodClearGates,  0},

  {"/_Sort",                NULL,         0,               0, "<Branch>"},
  {"/Sort/Pgam _Sort",      NULL,         MenuPgamSort,    0},
};











